package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.AmsSaleOrderMapper;
import com.steerinfo.dil.model.AmsSaleOrder;
import com.steerinfo.dil.service.IAmsSaleOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * AmsSaleOrder服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-06 07:10
 * 类描述
 * 修订历史：
 * 日期：2021-09-06
 * 作者：generator
 * 参考：
 * 描述：AmsSaleOrder服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amsSaleOrderService")
public class AmsSaleOrderServiceImpl implements IAmsSaleOrderService {

    @Autowired
    private AmsSaleOrderMapper amsSaleOrderMapper;

    @Override
    public List<Map<String, Object>> getSaleOrderInfo(Map<String, Object> map) {
        return amsSaleOrderMapper.getSaleOrderInfo(map);
    }

    @Override
    public List<Map<String, Object>> getSaleOrderReported(Map<String, Object> map) {
        return amsSaleOrderMapper.getSaleOrderReported(map);
    }

    @Override
    public List<Map<String, Object>> getSaleOrderDetail(Map<String,Object> map) {
        return amsSaleOrderMapper.getSaleOrderDetail(map);
    }

    @Override
    public List<Map<String, Object>> getSalePlanName() {
        return amsSaleOrderMapper.getSalePlanName();
    }

    @Override
    public List<Map<String, Object>> getShipperName() {
        return amsSaleOrderMapper.getShipperName();
    }

    @Override
    public List<Map<String, Object>> getConsigneeCompanyName() {
        return amsSaleOrderMapper.getConsigneeCompanyName();
    }

    @Override
    public int addAmsSaleOrder(AmsSaleOrder amsSaleOrder) {
        long id;
        if(amsSaleOrderMapper.selectMaxId()==null){
            id = 1;
        }else {
            id = amsSaleOrderMapper.selectMaxId().longValue()+1;
        }
        //生成主键id
        amsSaleOrder.setSaleOrderId(new BigDecimal(id));
        //WXSDD-年月日-8位数的顺序号
        Calendar now = Calendar.getInstance();
        String number = "WXSDD-" +  now.get(Calendar.YEAR);
        if ((now.get(Calendar.MONTH)+1) < 10) {
            number = number + "0" + (now.get(Calendar.MONTH)+1);
        }
        else {
            number = number + (now.get(Calendar.MONTH)+1);
        }
        if(now.get(now.DAY_OF_MONTH)<10){
            number = number + "0" + now.get(now.DAY_OF_MONTH)+"-";
        }
        else {
            number = number + now.get(now.DAY_OF_MONTH)+"-";
        }
        switch ((new BigDecimal(id).toString()).length()) {
            case 1:
                number = number + "0000000" + id;
                break;
            case 2:
                number = number + "000000" + id;
                break;
            case 3:
                number = number + "00000" + id;
                break;
            case 4:
                number = number + "0000" + id;
                break;
            case 5:
                number = number + "000" + id;
                break;
            case 6:
                number = number + "00" + id;
                break;
            case 7:
                number = number + "0" + id;
                break;
            default:number = number + id;
        }
        amsSaleOrder.setSaleNumber(number);
        amsSaleOrder.setSaleOrderStatus(new BigDecimal(0));
        amsSaleOrder.setSaleUnitPrice(new BigDecimal(4000));
        amsSaleOrder.setSaleOrderTax("13%");
        amsSaleOrder.setInsertUsername("admin");
        amsSaleOrder.setInsertTime(new Date());
        amsSaleOrder.setUpdateUsername("admin");
        amsSaleOrder.setUpdateTime(new Date());
        amsSaleOrder.setInsertUpdateRemark("无");
        amsSaleOrder.setDeleted(new BigDecimal(0));
        return amsSaleOrderMapper.insert(amsSaleOrder);
    }

    @Override
    public int uploadSaleOrder(BigDecimal saleOrderId) {
        AmsSaleOrder amsSaleOrder = amsSaleOrderMapper.selectByPrimaryKey(saleOrderId);
        amsSaleOrder.setSaleOrderStatus(new BigDecimal(1));
        return amsSaleOrderMapper.updateByPrimaryKey(amsSaleOrder);
    }

    @Override
    public List<Map<String, Object>> selectBySaleOrderId(BigDecimal saleOrderId) {
        return amsSaleOrderMapper.selectBySaleOrderId(saleOrderId);
    }

    @Override
    public int updateAmsSaleOrder(AmsSaleOrder amsSaleOrder) {
        amsSaleOrder.setUpdateTime(new Date());
        return amsSaleOrderMapper.updateByPrimaryKeySelective(amsSaleOrder);
    }

    @Override
    public int deleteAmsSaleOrderBySaleOrderId(BigDecimal saleOrderId) {
        //删除所有从表信息
        //amsSaleOrderMapper.deleteBySaleOrderId(saleOrderId);
        AmsSaleOrder amsSaleOrder = amsSaleOrderMapper.selectByPrimaryKey(saleOrderId);
        amsSaleOrder.setDeleted(new BigDecimal(1));
        return amsSaleOrderMapper.updateByPrimaryKey(amsSaleOrder);
    }

    @Override
    public List<Map<String, Object>> getSaleOrderUpdateLog(Map<String, Object> map) {
        return amsSaleOrderMapper.getSaleOrderUpdateLog(map);
    }

    @Override
    public List<Map<String, Object>> getAmsSaleOrderApproved(Map<String, Object> map) {
        return amsSaleOrderMapper.getAmsSaleOrderApproved(map);
    }
    @Override
    public List<Map<String, Object>> getSaleOrderList(Map<String, Object> mapValue) {
        return amsSaleOrderMapper.getSaleOrderList(mapValue);
    }

    public List<Integer>  getCarrier(Integer integer) {
        return amsSaleOrderMapper.getCarrier(integer);
    }
}
